package nl.kallestruik.dchat;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import net.kyori.adventure.text.format.TextColor;
import nl.kallestruik.dchat.commands.CommandCAdmin;
import nl.kallestruik.dchat.commands.CommandChat;
import nl.kallestruik.dchat.commands.CommandChatsettings;
import nl.kallestruik.dchat.commands.CommandEmojitest;
import nl.kallestruik.dchat.gson.TextColorTypeAdapter;
import nl.kallestruik.dchat.listeners.ChatListener;
import nl.kallestruik.dchat.listeners.JoinListener;
import nl.kallestruik.dchat.managers.EmojiManager;
import nl.kallestruik.dchat.managers.PlayerDataManager;
import org.bukkit.plugin.java.JavaPlugin;
import org.objectweb.asm.Type;

import javax.net.ssl.HttpsURLConnection;
import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.UUID;
import java.util.logging.Logger;

public final class DChat extends JavaPlugin {
    public static DChat instance;
    public static Logger logger;
    public static Gson gson = new GsonBuilder()
            .registerTypeAdapter(TextColor.class, new TextColorTypeAdapter())
            .create();
    public static String packHash = "";

    @Override
    public void onEnable() {
        instance = this;
        logger = this.getLogger();

        createDataFolderIfNotExists();

        updateResourcePackHash();

        EmojiManager.loadEmotesFromDisk();

        // Load console player data.
        PlayerDataManager.loadPlayerData(new UUID(0, 0));

        getServer().getPluginManager().registerEvents(new ChatListener(),this);
        getServer().getPluginManager().registerEvents(new JoinListener(), this);

        getCommand("emojitest").setExecutor(new CommandEmojitest());

        getCommand("chat").setExecutor(new CommandChat());
        getCommand("chat").setTabCompleter(new CommandChat());

        getCommand("chatsettings").setExecutor(new CommandChatsettings());
        getCommand("chatsettings").setTabCompleter(new CommandChatsettings());

        getCommand("cadmin").setExecutor(new CommandCAdmin());
        getCommand("cadmin").setTabCompleter(new CommandCAdmin());
    }

    @Override
    public void onDisable() {
        // Plugin shutdown logic
    }

    private void updateResourcePackHash() {
        packHash = Util.httpGET(Config.RESOURCE_PACK_URL_BASE + "get_hash.php");
    }

    private void createDataFolderIfNotExists() {
        File dataFolder = new File(this.getDataFolder(), "data");
        dataFolder.mkdirs();
    }
}
