package nl.kallestruik.dchat;


import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import javax.net.ssl.HttpsURLConnection;
import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.UUID;
import java.util.stream.Collectors;

public class Util {

    public static UUID getUUID(CommandSender sender) {
        // A UUID of all zero's is used as console.
        return sender instanceof Player ? ((Player) sender).getUniqueId() : new UUID(0, 0);
    }

    /**
     * Method to export a file from the jar to an external folder.
     *
     * @param resourceName the name of the resource
     * @param output file that will be outputted to
     */
    public static void exportResource(String resourceName, File output) {
        try (InputStream stream = Util.class.getResourceAsStream(resourceName); OutputStream resStreamOut = new FileOutputStream(output)) {
            if (stream == null) {
                throw new Exception("Cannot get resource \"" + resourceName + "\" from Jar file.");
            }

            int readBytes;
            byte[] buffer = new byte[4096];
            while ((readBytes = stream.read(buffer)) > 0) {
                resStreamOut.write(buffer, 0, readBytes);
            }
        } catch (Exception ex) {
            //Fail silently
        }
    }

    public static String httpGET(String url) {
        try {
            HttpURLConnection connection = ((HttpURLConnection) new URL(url).openConnection());
            connection.setRequestMethod("GET");
            connection.setRequestProperty("User-Agent", "DChat");
            try (BufferedReader reader = new BufferedReader(new InputStreamReader(connection.getInputStream()))) {
                return reader.lines().collect(Collectors.joining());
            }
        } catch (IOException e) {
            e.printStackTrace();
        }

        return "";
    }

}
