package nl.kallestruik.dchat.commands;

import nl.kallestruik.dchat.managers.EmojiManager;
import nl.kallestruik.dchat.managers.PlayerDataManager;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabCompleter;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.Arrays;
import java.util.List;
import java.util.UUID;
import java.util.stream.Collectors;

public class CommandCAdmin implements CommandExecutor, TabCompleter {
    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        if (args.length == 1 && args[0].equalsIgnoreCase("update-emotes")) {
            EmojiManager.updateEmotes();
            return true;
        } else if (args.length == 4 && args[0].equalsIgnoreCase("user")) {
            UUID uuid = Bukkit.getPlayer(args[2]).getUniqueId();
            switch (args[2]) {
                case "pingSound":
                    if (PlayerDataManager.changePingSoundSettingForUUID(uuid, args[3]))
                        sender.sendMessage("Changed ping sound to: " + args[3]);
                    else
                        sender.sendMessage("That is not a valid value!");
                    break;
                case "nameColor":
                    if (PlayerDataManager.changeNameColorSettingForUUID(uuid, args[3]))
                        sender.sendMessage("Changed name color to: " + args[3]);
                    else
                        sender.sendMessage("That is not a valid value!");
                    break;
                case "prefixColor":
                    if (PlayerDataManager.changePrefixColorSettingForUUID(uuid, args[3]))
                        sender.sendMessage("Changed prefix color to: " + args[3]);
                    else
                        sender.sendMessage("That is not a valid value!");
                    break;
                case "prefix":
                    String prefix = String.join(" ", Arrays.copyOfRange(args, 3, args.length));
                    if (PlayerDataManager.changePrefixSettingForUUID(uuid, prefix))
                        sender.sendMessage("Changed prefix to: " + prefix);
                    else
                        sender.sendMessage("That is not a valid value!");
                    break;
            }
        }


        return false;
    }

    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String alias, @NotNull String[] args) {
        if (args.length == 1)
            return List.of("update-emotes", "user").stream().filter((option) -> option.startsWith(args[0])).collect(Collectors.toList());

        if (args.length == 3) {
            switch (args[0]) {
                case "user": {
                    return List.of("pingSound", "nameColor", "prefixColor", "prefix").stream().filter((option) -> option.startsWith(args[1])).collect(Collectors.toList());
                }
            }
        }

        if (args.length == 4)
            switch (args[2]) {
                case "pingSound":
                    return List.of("Yes", "No");
                case "nameColor":
                case "prefixColor":
                    return List.of("#");
            }

        return null;
    }
}
