package nl.kallestruik.dchat.commands;

import net.kyori.adventure.text.Component;
import nl.kallestruik.dchat.managers.ChatManager;
import nl.kallestruik.dchat.managers.EmojiManager;
import nl.kallestruik.dchat.types.Emote;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabCompleter;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class CommandChat implements CommandExecutor, TabCompleter {
    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        if (args.length < 1)
            //TODO: Add warning that you need a chat message
            return true;

        ChatManager.sendMessage(sender, Component.text(String.join(" ", args)));

        return false;
    }

    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String alias, @NotNull String[] args) {
        if (args.length == 0)
            return null;

        String last = args[args.length - 1];

        // Tab completion for @ mentions.
        if (last.startsWith("@"))
            return Bukkit.getOnlinePlayers().stream().map((player) -> "@" + player.getName()).filter((name) -> name.startsWith(last)).collect(Collectors.toList());

        if (last.startsWith(":"))
            return EmojiManager.findMatches(last.substring(1)).stream().map(Map.Entry::getValue).map(Emote::getSymbol).collect(Collectors.toList());

        return null;
    }
}
