package nl.kallestruik.dchat.types;

import lombok.AllArgsConstructor;
import lombok.Data;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.event.HoverEvent;
import net.kyori.adventure.text.format.TextDecoration;

import java.util.List;

@Data
@AllArgsConstructor
public class Emote {
    private String name;
    private String symbol;
    private List<String> description;

    public HoverEvent<Component> getTooltip() {
        return HoverEvent.showText(
                Component.text(symbol)
                        .append(Component.text(":" + name + ":\n\n").decorate(TextDecoration.BOLD))
                        .append(Component.text(String.join("\n", description))));
    }
}
